/*Copyright 2006 Mathieu Lemire*/
#include<iostream>
#include<string>
#include<fstream>
#include<sstream>

#define L_LENGTH 1000000


#include "Prefile.hh"


class DescentPath
{


  int ** traitLocusAlleles;
  
  int ** pseudoMarkerAlleles;

  int nIndividuals;

  int nPedigrees;

  int * pedigreeBounds;
  
  
public:
  
  DescentPath( Prefile & P, int skip = 1 ){
    
    int i,j;
    char foo [32];

    nIndividuals = P.NIndividuals();
    nPedigrees = P.NPedigrees();
    
    traitLocusAlleles = new int * [nIndividuals];
    pseudoMarkerAlleles = new int * [nIndividuals];

    pedigreeBounds = new int [ nPedigrees + 1 ];
    for( i=0; i<nPedigrees+1; i++){
      pedigreeBounds[i] = P.PedigreeBounds(i);
    }

    for( i = 0; i<nIndividuals; i++){
      pseudoMarkerAlleles[i] = new int [2];
      traitLocusAlleles[i] = new int [2];
      istringstream tampon (P.RestOfLine(i));
      for( j=0; j<skip;j++) tampon >> foo;
      tampon>>traitLocusAlleles[i][0]>>traitLocusAlleles[i][1]>>pseudoMarkerAlleles[i][0]>>pseudoMarkerAlleles[i][1];
    }

  }
    
  ~DescentPath(){
    delete [] traitLocusAlleles;
    delete [] pseudoMarkerAlleles;
    delete pedigreeBounds;
  }

  int PseudoMarkerAlleles( int ind, int chr ){
    return pseudoMarkerAlleles[ind][chr];
  }

  void SetPseudoMarkerAlleles( int ind, int chr, int value){
    pseudoMarkerAlleles[ind][chr] = value;
  }

  int TraitLocusAlleles( int ind, int chr ){
    return traitLocusAlleles[ind][chr];
  }
  
  int  NIndividuals(){
    return nIndividuals;
  }
  int NPedigrees(){
    return nPedigrees;
  }
  int PedigreeBounds(int i){
    return pedigreeBounds[i];
  }

 

};
